/* Runner.p
 * Written by Scott Auge
 *
 * Muck around a bit with our SCRIPT_NAME and REQUEST_URI to figure out
 * what program we are running!
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/BlueDiamond/contrib1/RCS/runner.p,v 1.1 2002/03/13 05:57:10 sauge Exp $" NO-UNDO.

DEF VAR WebServer   AS CHARACTER NO-UNDO.
DEF VAR ScriptName  AS CHARACTER NO-UNDO.
DEF VAR RequestURI  AS CHARACTER NO-UNDO.
DEF VAR QueryString AS CHARACTER NO-UNDO.
DEF VAR RunProgram  AS CHARACTER NO-UNDO.

/* This stream used in sga_util.i */
DEF NEW SHARED STREAM StdOut.

/* Load up what the webserver handed to us */

ASSIGN
WebServer = OS-GETENV("SERVER_SOFTWARE")
ScriptName = OS-GETENV("SCRIPT_NAME")
QueryString = OS-GETENV("QUERY_STRING").

IF INDEX(WebServer,"Apache") > 0 THEN DO:
  RequestURI = OS-GETENV("REQUEST_URI").

  /* The program we want is after the Script Name, 
     but without the Query String. 		*/
  RunProgram = REPLACE (RequestURI, ScriptName + "/", ""). 
  RunProgram = REPLACE (RunProgram, "?" + QueryString, "").

END.

ELSE DO:
  RequestURI = OS-GETENV("PATH_INFO").

  RunProgram = RequestURI.
  IF RunProgram BEGINS "/" THEN
    RunProgram = SUBSTRING(RunProgram,2).
END.

/* Convert to the .p convention and RUN */
RunProgram = REPLACE(RunProgram,".html",".p").

OUTPUT STREAM StdOut THROUGH /bin/cat - UNBUFFERED. 
{rxdbconnect.i} /* Connect DB's */
RUN VALUE(RunProgram).
OUTPUT STREAM StdOut CLOSE.
