/* rxdbconnect.i - Based on a psuedo PF file, make DB connection.
This was originally done to attempt to make the BD installation more
reliable and self-diagnosing.   The idea was that instead of the user
getting some generic Apache Error, they would get a nice message AND
we would immediately notify the admin staff...

HOWEVER, I'm no longer sure how great an idea this is.  Connections 
done on the command line or via .pf file are run whilst Progress is 
in Super-duper-user mode.    Connections done in this program are 
done as the user "nobody".    There are several reasons they might NOT
connect:

A. Don't have write perms on the db files and logs.  In this situation
it will run, detect it, give message, and quit.   Fix with chmod.

B. Don't have write perms on the shared memory segments.   In this 
situation this code will crap out with an error we cannot catch.  The
only way I know of fixing it is run a C program I wrote which does 
shmget() calls to make it rw rw rw.  (shmmod, along with script shmmodall)
In theory this can be integrated into the server startup procedure. 

SO, operationally, this approach is slightly MORE likely to fail to
connect, but much nicer about handling it. 

In the context of BlueDiamond, we are trying to use the same .pf file
for this AND for the batch compile functions.   There is a bit of funky 
here in that IF this code reads it, it cannot have any non-connect
syntax.  You can put a "-h NN" line in, which it will ignore. 

Notify staff and provide a rational user response if not.   This presumes
that the environmental variable DBPFNAME has been set to point to a 
text file which looks very much like a progress .pf file but ONLY 
refers to databases and ONLY one DB per line like this:
	-db /ld3/db/dbname1 -ld prov
	-db /ld3/db/dbname2 -ld dclaim -H host1 -S service1
	-db /ld3/db/dbname3

You will no doubt want to re-word the messages and server names to 
suit your application.   The rxnotifydbdown script is intended to call
pagers and send email after logging the condtion. 

*/

/* Added revision control code and precompiler controls by Scott Auge */

&IF DEFINED(RXDBCONNECT_I) <> 1 &THEN
&GLOBAL-DEFINE RXDBCONNECT_I Y

DEF VAR RCSVersionRXDBConnect AS CHARACTER INIT "$Header: /home/appl/BlueDiamond/contrib1/RCS/rxdbconnect.i,v 1.3 2002/03/13 06:01:54 sauge Exp sauge $" NO-UNDO.

def var w_db-name as char format "x(30)" no-undo.
def var w_db-msg as char format "x(76)" no-undo.
def var w_db-connect-errors as logical init false.
def var w_pfname as char no-undo.
        w_pfname = OS-GETENV("PFFILE").

if w_pfname <> ? then do:
	define stream pffile. 
	input stream pffile from value(w_pfname) no-echo.
	repeat:
                import stream pffile unformatted w_db-name.
                if w_db-name begins "-h" then next.
                if w_db-name begins "-db" then
                        w_db-name = substring(w_db-name, 4).

		connect value (w_db-name) no-error.
		if error-status:error then do:
			w_db-msg = w_db-msg 
				+ error-status:get-message(1) + " ;".
			w_db-connect-errors = true.
			/* display w_db-msg.*/
			end.
			
		end.
	input stream pffile close.

	if w_db-connect-errors then do:
		unix silent (value("/usr/local/bin/rxnotifydbdown ~"Nimitz: " 
				+ w_db-msg + ";"
				+ OS-GETENV("REMOTE_USER") + ";"
				+ OS-GETENV("REMOTE_ADDR") + ";"
				+ OS-GETENV("SCRIPT_NAME") + ";"
				+ OS-GETENV("REQUEST_URI") + "~"" ) ).

		PUT STREAM StdOut "Content-Type:text/html ~n~n".
		PUT STREAM StdOut "<HTML> <BODY BGCOLOR=~"#FFFFFF~"> "
"<h1><center>Database Connection Problem</center></h1> <hr>"
"<p>We are sorry, but we cannot process your Rxplorer request because we "
"cannot get connected to all our databases.  However, we HAVE notified "
"HID staff about this problem, and they should get back to you as soon "
"as they have rectified it.   Thanks for being patient and for using "
"Rxplorer.</HTML>" skip.
		OUTPUT STREAM StdOut CLOSE.
		quit. 
		end.
	end.

/* We would like to catch three situations:

1. The .r in question doesn't exist.
2. The .p in question won't compile.  Actually we DONT want to be session
compiling things, so while running a .p is acceptable to the user, we really 
should make a note to ourselves to compile the darned thing. 

We cannot catch these situations:
- The .r does exist but CRC no longer matches due to DB change. 
*/
/* 
if search(RunProgram) = ? then do:
		unix silent (value("/usr/local/bin/rxnotifydbdown ~"Nimitz: " 
				+ "No Program;" + RunProgram + "~"" ) ).
		PUT STREAM StdOut "Content-Type:text/html ~n~n".
		PUT STREAM StdOut "<HTML> <BODY BGCOLOR=~"#FFFFFF~"> "
"<h1><center>Program Problem</center></h1> <hr>"
"<p>We are sorry, but we cannot process your Rxplorer request because we "
"cannot locate the program specified.  However, we HAVE notified "
"HID staff about this problem, and they should get back to you as soon "
"as they have rectified it.   Thanks for being patient and for using "
"Rxplorer.</HTML>" skip.
		OUTPUT STREAM StdOut CLOSE.
		quit.
		end.

*/

&ENDIF

