/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

&IF DEFINED(ABBRREGARD_I) = 0 &THEN
&GLOBAL-DEFINE ABBRREGARD_I YEP

DEF VAR RCSVersionAbbrRegard_i AS CHARACTER INIT "$Header: /home/appl/opensrc/kitty/RCS/AbbrRegard.i,v 1.1 2002/05/04 21:19:24 sauge Exp sauge $" NO-UNDO. 

/* Reads in the number of re: in cText and returns re[n]: */

FUNCTION nAbbrRegard RETURNS INTEGER (INPUT cText AS CHARACTER, INPUT iCount AS INTEGER):

  ASSIGN iCount = iCount + 1.
  ASSIGN cText = SUBSTRING(cText, 5, LENGTH(cText)).
  IF cText BEGINS "re:" THEN 
    iCount = nAbbrRegard (cText, iCount).

  RETURN iCount.

END. 

FUNCTION AbbrRegard RETURNS CHARACTER (INPUT cText AS CHARACTER):

  DEF VAR i AS INTEGER NO-UNDO.

  ASSIGN i = 0.
  IF cText BEGINS "re: " THEN DO:
    i = nAbbrRegard (cText, i).
    IF i > 1 THEN 
      RETURN "re[" + STRING(i) + "]:" + SUBSTRING(cText, i * 4, LENGTH(cText)).
    ELSE 
      RETURN "re:" + SUBSTRING(cText, i * 4, LENGTH(cText)).
  END.

  RETURN cText.

END.

&ENDIF

