/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

&IF DEFINED(MAKEURL_I) <> 1 &THEN
&GLOBAL-DEFINE MAKEURL_I Y

DEF VAR RCSVersionMakeURL AS CHARACTER INIT "$Header: /home/appl/BlueDiamond/prgsrc/RCS/MakeURL.i,v 1.2 2002/04/04 21:27:22 sauge Exp $" NO-UNDO.

/* Uses the program name and the PROPATH to create a URL for the page */
/* cFileName should be the complete path and file name, not something */
/* off the PROPATH.                                                   */

FUNCTION MakeURL RETURNS CHARACTER
(
 INPUT cHostName AS CHARACTER,
 INPUT cScriptName AS CHARACTER,
 INPUT cFileName AS CHARACTER
):

  DEF VAR cSubPath    AS CHARACTER NO-UNDO.
  DEF VAR cReturn     AS CHARACTER NO-UNDO.

  DEF VAR iNumDir     AS INTEGER NO-UNDO.
  DEF VAR iCurDir     AS INTEGER NO-UNDO.
  DEF VAR cCurDir     AS CHARACTER NO-UNDO.

  /* Find the subdirectory the file is in off the propath */

  ASSIGN iNumDir = NUM-ENTRIES(PROPATH).
  DO iCurDir = 1 TO iNumDir:
    ASSIGN cCurDir = ENTRY(iCurDir, PROPATH).
    IF cFileName BEGINS cCurDir AND cCurDir <> "" THEN DO:
      cSubPath = REPLACE (cFileName, cCurDir, "").
      LEAVE. 
    END. /* IF cSearchPath BEGINS cCurDir */
  END. /* DO iCurDir = 1 TO iNumDir */

  /* Return to the caller */

  ASSIGN cReturn = "http://" + cHostName 
                 + cScriptName 
                 + cSubPath.

  RETURN cReturn.

END. /* FUNCTION MakeURL RETURNS CHARACTER */

&ENDIF

