/* sga_util.i
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

&IF DEFINED(CNV4GL_UTIL_I) <> 1 &THEN
&GLOBAL-DEFINE CNV4GL_UTIL_I  YES


DEF VAR RCSVersionsgautil AS CHARACTER INIT "$Header: /home/appl/BlueDiamond/prgsrc/RCS/cnv4gl_util.i,v 1.3 2002/02/20 14:22:55 sauge Exp $" NO-UNDO.

/* Prep CGI Varibles */

DEF VAR AUTH_TYPE          AS CHARACTER NO-UNDO.
DEF VAR CONTENT_LENGTH     AS CHARACTER NO-UNDO.
DEF VAR CONTENT_TYPE       AS CHARACTER NO-UNDO.
DEF VAR GATEWAY_INTERFACE  AS CHARACTER NO-UNDO.
DEF VAR HTTP_ACCEPT        AS CHARACTER NO-UNDO.
DEF VAR HTTP_COOKIE        AS CHARACTER NO-UNDO.
DEF VAR HTTP_REFERER       AS CHARACTER NO-UNDO.
DEF VAR HTTP_USER_AGENT    AS CHARACTER NO-UNDO.
DEF VAR PATH_INFO          AS CHARACTER NO-UNDO.
DEF VAR PATH_TRANSLATED    AS CHARACTER NO-UNDO.
DEF VAR QUERY_STRING       AS CHARACTER NO-UNDO.
DEF VAR REMOTE_ADDR        AS CHARACTER NO-UNDO.
DEF VAR REMOTE_HOST        AS CHARACTER NO-UNDO.
DEF VAR REMOTE_IDENT       AS CHARACTER NO-UNDO.
DEF VAR REMOTE_USER        AS CHARACTER NO-UNDO.
DEF VAR REQUEST_METHOD     AS CHARACTER NO-UNDO.
DEF VAR SCRIPT_NAME        AS CHARACTER NO-UNDO.
DEF VAR SERVER_NAME        AS CHARACTER NO-UNDO.
DEF VAR SERVER_PORT        AS CHARACTER NO-UNDO.
DEF VAR SERVER_PROTOCOL    AS CHARACTER NO-UNDO.
DEF VAR SERVER_SOFTWARE    AS CHARACTER NO-UNDO.

DEF NEW SHARED STREAM StdOut.

ASSIGN
AUTH_TYPE          = OS-GETENV("AUTH_TYPE")
CONTENT_LENGTH     = OS-GETENV("CONTENT_LENGTH")
CONTENT_TYPE       = OS-GETENV("CONTENT_TYPE")
GATEWAY_INTERFACE  = OS-GETENV("GATEWAY_INTERFACE")
HTTP_ACCEPT        = OS-GETENV("HTTP_ACCEPT")
HTTP_COOKIE        = OS-GETENV("HTTP_COOKIE")
HTTP_REFERER       = OS-GETENV("HTTP_REFERER")
HTTP_USER_AGENT    = OS-GETENV("HTTP_USER_AGENT")
PATH_INFO          = OS-GETENV("PATH_INFO")
PATH_TRANSLATED    = OS-GETENV("PATH_TRANSLATED")
QUERY_STRING       = OS-GETENV("QUERY_STRING")
REMOTE_ADDR        = OS-GETENV("REMOTE_ADDR")
REMOTE_HOST        = OS-GETENV("REMOTE_HOST")
REMOTE_IDENT       = OS-GETENV("REMOTE_IDENT")
REMOTE_USER        = OS-GETENV("REMOTE_USER")
REQUEST_METHOD     = OS-GETENV("REQUEST_METHOD")
SCRIPT_NAME        = OS-GETENV("SCRIPT_NAME")
SERVER_NAME        = OS-GETENV("SERVER_NAME")
SERVER_PORT        = OS-GETENV("SERVER_PORT")
SERVER_PROTOCOL    = OS-GETENV("SERVER_PROTOCOL")
SERVER_SOFTWARE    = OS-GETENV("SERVER_SOFTWARE").

DEF VAR REQUEST_URI AS CHARACTER NO-UNDO.

ASSIGN
REQUEST_URI        = OS-GETENV("REQUEST_URI").

/* Contact C code in the library StdOut.so - this code takes over stdout */
/* and puts our goodies out without any framing stuff from Progress.     */

PROCEDURE WriteStdOut EXTERNAL "/appl/BlueDiamond/lib/BlueDiamond.so" CDECL:

  DEF INPUT PARAMETER pText AS CHARACTER.
  DEF RETURN PARAMETER i AS SHORT.

END.

/* Wrapper C code so the syntax is a bit cleaner. Programs run though */
/* e4glprs.p use this function extensively.                           */

PROCEDURE WrtStdOut:

  DEF INPUT PARAMETER pText AS CHARACTER NO-UNDO.
  DEF VAR i AS INTEGER NO-UNDO.

  RUN WriteStdOut (pText, OUTPUT i).

END.

/* Use this to set the content so HTTP Header syntax is not needed to be */
/* known by the programmer.                                              */

PROCEDURE SetContent:

  DEF INPUT PARAMETER pContentType AS CHARACTER NO-UNDO.

  RUN WrtStdOut ("Content-Type:" + pContentType + "~n~n").

  /* If your using this, you must leave this in here.  */

  IF pContentType = "text/html" OR pContentType = "html/text" THEN DO:
    RUN WrtStdOut ("<!-- Portions Copyright Scott Auge sauge@aezinc.com - Blue Diamond Internet Transaction Server -->").
  END.

END.

/* Start of functions to parse QUERY_STRING and HTTP_COOKIE to obtain */
/* values from.  Attempting to match Progress functions as much as    */
/* possible so E4GL code will function with little modification.  In  */
/* the future these may end up in the shared library, cuz string man- */
/* ipulations are sloooooow.  But fast enough for now.                */


/* With this function, we extract the QUERY_STRING that came from the CGI */
/* of the webserver.  We have a 32K limit on the size of this data.       */

FUNCTION Get-Field RETURNS CHARACTER (INPUT T AS CHARACTER):

  DEF VAR i      AS INTEGER NO-UNDO.
  DEF VAR CGIVar AS CHARACTER NO-UNDO.
  DEF VAR NVP    AS CHARACTER NO-UNDO.
  DEF VAR r      AS CHARACTER NO-UNDO.

  IF REQUEST_METHOD = "GET" THEN
    ASSIGN CGIVar = OS-GETENV("QUERY_STRING").

  /* When processing a post, the post data is stored in an environmental */
  /* varible called POSTDATA in the script that calls runner.p.  In      */
  /* other words, you want:                                              */
  /*  export POSTDATA=$(cat -)                                           */
  /* in your calling script to capture POST data from stdin before get-  */
  /* ting here!                                                          */

  ELSE 
    ASSIGN CGIVar = OS-GETENV("POSTDATA").

  /* We usually get +'s for spaces in this data, so lets clean it up some */

  ASSIGN CGIVar = REPLACE (CGIVar, "+", " ").
 
  /* Use for practicin' my parsin' */
  /* ASSIGN CGIVar = "this=ah&that=oh". */

  /* Look through our assorted nvp, if we have two or more nvp's with the */
  /* same name, make a comma delimited list out of the value.             */

  DO i = 1 TO NUM-ENTRIES (CGIVar,"&"):

    ASSIGN NVP = ENTRY(i, CGIVar, "&")
           r = "".

    /* If we have a winner! */

    IF INDEX (NVP, T) <> 0 THEN DO:

      ASSIGN r = r +
                 IF r <> "" THEN "," + ENTRY (2, NVP, "=")
                 ELSE ENTRY(2, NVP, "=").

      RETURN r.

    END. 

  END.

  RETURN "".

END. /* FUNCTION Get-Field () */

/* With this function, we examine the cookies that were sent back from the */
/* CGI of the web server.  We have a 32K limit on the size of this data.   */

FUNCTION Get-Cookie RETURNS CHARACTER (INPUT T AS CHARACTER):

  DEF VAR i      AS INTEGER NO-UNDO.
  DEF VAR CGIVar AS CHARACTER NO-UNDO.
  DEF VAR NVP    AS CHARACTER NO-UNDO.
  DEF VAR r      AS CHARACTER NO-UNDO.

  ASSIGN CGIVar = OS-GETENV("HTTP_COOKIE").

  /* Use for practicin' my parsin' */
  /* ASSIGN CGIVar = "this=ah;that=oh". */

  /* Look through our assorted nvp, if we have two or more nvp's with the */
  /* same name, make a comma delimited list out of the value.             */

  DO i = 1 TO NUM-ENTRIES (CGIVar,";"):

    ASSIGN NVP = ENTRY(i, CGIVar, ";")
           r = "".

    /* If we have a winner! */

    IF INDEX (NVP, T) <> 0 THEN DO:

      ASSIGN r = r +
                 IF r <> "" THEN "," + ENTRY (2, NVP, "=")
                 ELSE ENTRY(2, NVP, "=").

      RETURN r.

    END. 

  END.

  RETURN "".

END. /* FUNCTION Get-Cookie () */

/* In this function, we search a field or a cookie for a name value   */
/* pair (nvp).                                                        */

FUNCTION Get-Value RETURNS CHARACTER (INPUT T AS CHARACTER):

  DEF VAR r AS CHARACTER NO-UNDO.

  ASSIGN r = Get-Field (t).

  IF r = "" THEN
    ASSIGN r = Get-Cookie (t).

  RETURN r.

END. /* FUNCTION Get-Value () */

/* The following sets a cookie based on the set-cookie API arguments */
/* from Progress.  The cookie syntax is derived from RFC2109 avail-  */
/* able here: http://www.cis.ohio-state.edu/htbin/rfc/rfc2109.html   */
/* Warning: This function assumes you got a clue, unlike Progress' - */
/* there is little value checking.                                   */

FUNCTION Set-Cookie RETURNS CHARACTER
 (INPUT pName    AS CHARACTER,
  INPUT pValue   AS CHARACTER,
  INPUT pDate    AS DATE,
  INPUT pTime    AS INTEGER,
  INPUT pPath    AS CHARACTER,
  INPUT pDomain  AS CHARACTER,
  INPUT pOptions AS CHARACTER):

  DEF VAR CookiePhrase AS CHARACTER NO-UNDO.
/*
  DEF VAR SCRIPT_NAME AS CHARACTER NO-UNDO.
  DEF VAR SERVER_NAME AS CHARACTER NO-UNDO.

  ASSIGN SCRIPT_NAME = OS-GETENV("SCRIPT_NAME")
         SERVER_NAME = OS-GETENV("SERVER_NAME").
*/
  /* Determine if we are getting unknowns, if so, then we want or defaults */
  /* NOTE: Where domain, we use server name.  This may not jive with what  */
  /* Progress did with their set-cookie function.                          */

  ASSIGN
  pName    = IF pName = ? THEN "" ELSE pName
  pValue   = IF pValue = ? THEN "" ELSE pValue
  /* pDate    = IF pDate = ? THEN "" ELSE pDate */
  /* pTime    = IF pTime = ? THEN "" ELSE pTime */
  pPath    = IF pPath = ? THEN SCRIPT_NAME ELSE pPath
  pDomain  = IF pDomain = ? THEN SERVER_NAME ELSE pDomain
  pOptions = IF pOptions = ? THEN "" ELSE pOptions.

  ASSIGN CookiePhrase = 'Set-Cookie:&1=&2; Version=1; Path=&3;'.

  ASSIGN CookiePhrase = SUBSTITUTE (CookiePhrase,
                                    pName,
                                    pValue,
                                    pPath,
                                    pDomain).

  RUN WrtStdOut (INPUT CookiePhrase).

  RETURN CookiePhrase.

END FUNCTION.  /* set-cookie */

/* Delete a cookie.  Basically a call to set-cookie() with a blank value */

FUNCTION Delete-Cookie RETURNS CHARACTER (INPUT CookieName AS CHARACTER):

  return set-cookie (CookieName, "", ?, ?, ?, ?, ?).

END.

/* There are times when data may contain HTML meta characters.  Use this */
/* function to use the tokens that should be used for these.  Compatible */
/* with Progress Web-Speed.  Note you want to do the & first, else you   */
/* will smack yourself in the head later.                                */

FUNCTION HTML-Encode RETURNS CHARACTER (INPUT pText AS CHARACTER):

  ASSIGN pText = REPLACE (pText, "&", "&amp;") 
         pText = REPLACE (pText, "~"", "&quot;") 
         pText = REPLACE (pText, "<", "&lt;") 
         pText = REPLACE (pText, ">", "&gt;") .

  RETURN pText.

END. 

/* This is used in E4GL in a lot of programs.  The formatting should al- */
/* ready be appropriate for the PUT statement by the programmer.         */

&GLOBAL-DEFINE OUT PUT STREAM StdOut UNFORMATTED 

/* Some existing E4GL programs use the OUTPUT-HEADERS internal procedure. */
/* To make this the most compatible as possible, see if there is an in-   */
/* ternal procedure called OUTPUT-HEADERS and run it if it exists.        */

IF THIS-PROCEDURE:GET-SIGNATURE("OUTPUT-HEADERS") BEGINS "procedure" THEN
  RUN OUTPUT-HEADERS.

&ENDIF

