/* Runner.p
 * Written by Scott Auge
 *
 * Muck around a bit with our SCRIPT_NAME and REQUEST_URI to figure out
 * what program we are running!
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/BlueDiamond/prgsrc/RCS/runner.p,v 1.6 2002/04/12 14:28:52 sauge Exp $" NO-UNDO.

DEF VAR WebServer   AS CHARACTER NO-UNDO.
DEF VAR ScriptName  AS CHARACTER NO-UNDO.
DEF VAR RequestURI  AS CHARACTER NO-UNDO.
DEF VAR QueryString AS CHARACTER NO-UNDO.
DEF VAR RunProgram  AS CHARACTER NO-UNDO.

/* This stream used in sga_util.i */
DEF NEW SHARED STREAM StdOut.

{SetPostFix.i}
{PostFix.i}

/* Load up what the webserver handed to us */

ASSIGN
WebServer = OS-GETENV("SERVER_SOFTWARE")
ScriptName = OS-GETENV("SCRIPT_NAME")
QueryString = OS-GETENV("QUERY_STRING").

IF INDEX(WebServer,"Apache") > 0 THEN DO:
  RequestURI = OS-GETENV("REQUEST_URI").

  /* The program we want is after the Script Name, 
     but without the Query String. 		*/
  RunProgram = REPLACE (RequestURI, ScriptName + "/", ""). 
  RunProgram = REPLACE (RunProgram, "?" + QueryString, "").

END.

ELSE DO:
  RequestURI = OS-GETENV("PATH_INFO").

  RunProgram = RequestURI.
  IF RunProgram BEGINS "/" THEN
    RunProgram = SUBSTRING(RunProgram,2).
END.

/* Convert to the .p convention and RUN */
IF PostFix(RunProgram) = ".html" OR PostFix(RunProgram) = ".htm" THEN
  ASSIGN RunProgram = REPLACE(RunProgram,".html",".p")
         RunProgram = REPLACE(RunProgram, ".htm", ".p").
ELSE 
  ASSIGN RunProgram = RunProgram + ".p".

IF OPSYS = "WIN32" THEN
  OUTPUT STREAM StdOut THROUGH "F:\perl\bin\perl.exe F:\bin\cat.pl" UNBUFFERED.
ELSE 
  OUTPUT STREAM StdOut THROUGH /bin/cat - UNBUFFERED.

RUN VALUE(RunProgram).
OUTPUT STREAM StdOut CLOSE.
