/* sga_util.i
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

&IF DEFINED(SGA_UTIL_I) <> 1 &THEN
&GLOBAL-DEFINE SGA_UTIL_I Y

DEF VAR RCSVersionsgautil AS CHARACTER INIT "$Header: /home/appl/BlueDiamond/prgsrc/RCS/sga_util.i,v 1.21 2002/11/17 04:18:07 sauge Exp sauge $" NO-UNDO.

&GLOBAL-DEFINE OUT PUT STREAM StdOut UNFORMATTED
&GLOBAL-DEFINE DISPLAY DISPLAY STREAM StdOut 

&GLOBAL-DEFINE EXPIRE NO

{MakeURL.i}
{Config.i}

/* Prep CGI Varibles */

DEF VAR AUTH_TYPE          AS CHARACTER NO-UNDO.
DEF VAR CONTENT_LENGTH     AS CHARACTER NO-UNDO.
DEF VAR CONTENT_TYPE       AS CHARACTER NO-UNDO.
DEF VAR GATEWAY_INTERFACE  AS CHARACTER NO-UNDO.
DEF VAR HTTP_ACCEPT        AS CHARACTER NO-UNDO.
DEF VAR HTTP_COOKIE        AS CHARACTER NO-UNDO.
DEF VAR HTTP_REFERER       AS CHARACTER NO-UNDO.
DEF VAR HTTP_USER_AGENT    AS CHARACTER NO-UNDO.
DEF VAR PATH_INFO          AS CHARACTER NO-UNDO.
DEF VAR PATH_TRANSLATED    AS CHARACTER NO-UNDO.
DEF VAR QUERY_STRING       AS CHARACTER NO-UNDO.
DEF VAR REMOTE_ADDR        AS CHARACTER NO-UNDO.
DEF VAR REMOTE_HOST        AS CHARACTER NO-UNDO.
DEF VAR REMOTE_IDENT       AS CHARACTER NO-UNDO.
DEF VAR REMOTE_USER        AS CHARACTER NO-UNDO.
DEF VAR REQUEST_METHOD     AS CHARACTER NO-UNDO.
DEF VAR SCRIPT_NAME        AS CHARACTER NO-UNDO.
DEF VAR SERVER_NAME        AS CHARACTER NO-UNDO.
DEF VAR SERVER_PORT        AS CHARACTER NO-UNDO.
DEF VAR SERVER_PROTOCOL    AS CHARACTER NO-UNDO.
DEF VAR SERVER_SOFTWARE    AS CHARACTER NO-UNDO.
DEF VAR last-modified      AS CHARACTER NO-UNDO.

DEF SHARED STREAM StdOut.

ASSIGN
AUTH_TYPE          = OS-GETENV("AUTH_TYPE")
CONTENT_LENGTH     = OS-GETENV("CONTENT_LENGTH")
CONTENT_TYPE       = OS-GETENV("CONTENT_TYPE")
GATEWAY_INTERFACE  = OS-GETENV("GATEWAY_INTERFACE")
HTTP_ACCEPT        = OS-GETENV("HTTP_ACCEPT")
HTTP_COOKIE        = OS-GETENV("HTTP_COOKIE")
HTTP_REFERER       = OS-GETENV("HTTP_REFERER")
HTTP_USER_AGENT    = OS-GETENV("HTTP_USER_AGENT")
PATH_INFO          = OS-GETENV("PATH_INFO")
PATH_TRANSLATED    = OS-GETENV("PATH_TRANSLATED")
QUERY_STRING       = OS-GETENV("QUERY_STRING")
REMOTE_ADDR        = OS-GETENV("REMOTE_ADDR")
REMOTE_HOST        = OS-GETENV("REMOTE_HOST")
REMOTE_IDENT       = OS-GETENV("REMOTE_IDENT")
REMOTE_USER        = OS-GETENV("REMOTE_USER")
REQUEST_METHOD     = OS-GETENV("REQUEST_METHOD")
SCRIPT_NAME        = OS-GETENV("SCRIPT_NAME")
SERVER_NAME        = OS-GETENV("SERVER_NAME")
SERVER_PORT        = OS-GETENV("SERVER_PORT")
SERVER_PROTOCOL    = OS-GETENV("SERVER_PROTOCOL")
SERVER_SOFTWARE    = OS-GETENV("SERVER_SOFTWARE").

DEF VAR REQUEST_URI AS CHARACTER NO-UNDO.

ASSIGN
REQUEST_URI        = OS-GETENV("REQUEST_URI").

/* Use this to store the content type's default.  The user can use */
/* output-content-type() to reset from the default.                */

DEF VAR c_BlueDiamond_DefaultContentType AS CHARACTER NO-UNDO.
ASSIGN c_BlueDiamond_DefaultContentType = "text/html".

/* This is a built in varible found in Webspeed.  The Wizards seem */
/* to favor it.                                                    */

DEF VAR SelfURL AS CHARACTER NO-UNDO.

ASSIGN SelfURL = MakeURL(SERVER_NAME, SCRIPT_NAME, search(program-name (1))).

/* Allow the user to set the content type.                      */
/* Warning:  This is not exactly like Webspeed's implementation */

FUNCTION OutPut-Content-Type RETURNS LOGICAL
(INPUT cContentType AS CHARACTER ):

  DEF VAR cReturnValue AS LOGICAL NO-UNDO.

  ASSIGN cReturnValue = TRUE.
  IF cContentType = "" THEN ASSIGN cReturnValue = FALSE.

  ASSIGN c_BlueDiamond_DefaultContentType = cContentType.
  RETURN cReturnValue.

END. /* FUNCTION OutPut-Content-Type */

/* Encodes unsafe characters in a URL per RFC 1738          */
/* section 2.2, available at:                               */
/* URL:http://ds.internic.net/rfc/rfc1738.txt,              */
/* plus ASCII values between 0 and 31 and between 127       */
/* and 255. Opwtions modify the encode to handle URL         */
/* query strings, persistent cookies, or a specified string */
/* of characters. Returns the encoded string.               */

FUNCTION IntToHex RETURNS CHARACTER (INPUT n AS INTEGER):

  DEF VAR HexAlphabet AS CHARACTER INIT "0,1,2,3,4,5,6,7,8,9,a,b,c,d,e,f" NO-UNDO.

  RETURN (IF n > 15 THEN intToHex( INTEGER(TRUNCATE(n / 16, 0))) ELSE "")
          + ENTRY(n MOD 16 + 1, HexAlphabet).

END. /* IntToHex */

FUNCTION BASE-URL-ENCODE RETURNS CHARACTER (INPUT t AS CHARACTER):

  DEF VAR i AS INTEGER NO-UNDO.   /* Where we at in the string? */
  DEF VAR c AS CHARACTER NO-UNDO. /* Character we are examining for conv */
  DEF VAR l AS INTEGER NO-UNDO.   /* Size of string */
  DEF VAR r AS CHARACTER NO-UNDO. /* The output string */
  DEF VAR UnSafe AS CHARACTER NO-UNDO.
  def var w-hex as character no-undo. /* for building hex number */

  /* These are characters that could confuse a browser when they really */
  /* are meant to be sent as data to a program.  Stuff like # is a hard */
  /* anchor, ? & = are used in sending name value pairs (NVP), etc.     */

  ASSIGN Unsafe = "~"~{~}~/~#~[~]~.~~~%~<~>~|~\~^~`~;".
  ASSIGN Unsafe = Unsafe + "~?~:~&~@~=~ ".

  ASSIGN 
  r = ""
  l = LENGTH(t).

  DO i = 1 TO l:
    
    ASSIGN c = SUBSTRING (t, i, 1).

    /* Assign characters that are 0 - 31 to their hex representations */
    /* Update from Daryl - was returning %e when should be %0e        */

    IF ASC (c) >= 0 AND ASC (c) <= 31 THEN DO:
      w-hex = IntToHex (ASC (c)).
      w-hex = fill("0",2 - length(w-hex)) + w-hex.
      ASSIGN r = r + "%" + w-hex.
      NEXT.
    END.  /* 0 <= ASCII c <= 31 */

    /* Assign characters that are 127-255 to their hex representations */

    IF ASC (c) >= 127 AND ASC (c) <= 255 THEN DO:
      ASSIGN r = r + "%" + IntToHex (ASC (c)).
      NEXT.
    END.  /* 127 <= ASCII c <= 255 */

    /* Check if the character is one of the unsafe characters */

    IF INDEX (UnSafe, c) <> 0 THEN DO:
      ASSIGN r = r + "%" + IntToHex (ASC (c)).
      NEXT.
    END.  /* Is an unsafe character */

    /* The character has passed all tests and can be left alone */

    ASSIGN r = r + c.

  END. /* DO i = 1 TO l */

  RETURN r.

END. /* FUNCTION BASE-URL-ENCODE () */

/* The original version of URL-ENCODE had only one argument.  The actual */
/* Progress version has two.  Use this preprocessor to determine which   */
/* one the developers actually want to use.                              */

&IF "{&ORGURLENCODE}" = "YES" &THEN

FUNCTION URL-ENCODE RETURNS CHARACTER
(INPUT T AS CHARACTER):

  RETURN BASE-URL-ENCODE(T).

END.  /* FUNCTION URL-ENCODE() */

&ELSE

/* This function will encode special characters all the time, but has the */
/* two arguments that the progress one would have.                        */

FUNCTION URL-ENCODE RETURNS CHARACTER 
(INPUT A AS CHARACTER ,
 INPUT B AS CHARACTER ):

  RETURN BASE-URL-ENCODE(A).

END.  /* FUNCTION URL-ENCODE() */

&ENDIF

/* Some data comes in with %hh hexidecimal notation to represent meta    */
/* characters.  Use this function to convert Hex to Int.                 */

FUNCTION HexToInt RETURNS INTEGER (INPUT Hex AS CHAR):

  DEF VAR HexAlphabet AS CHARACTER INIT "0123456789abcdef" NO-UNDO.
  DEF VAR HexPower    AS CHARACTER INIT "1,16,256,4096,65536,1048576,16888216,268435456" NO-UNDO.

  DEF VAR fc AS CHARACTER NO-UNDO.
  DEF VAR ix AS INTEGER NO-UNDO.

  ASSIGN
  fc = SUBSTRING(Hex,1,1)
  ix = INDEX(HexAlphabet, fc) - 1.

  IF fc = "" THEN RETURN 0.

  ELSE RETURN (ix * INTEGER(ENTRY(LENGTH(Hex), HexPower))) 
              + hexToInt(SUBSTRING(Hex,2)).

END. /* FUNCTION HexToInt */

/* This function will take a string and search for hexidecimal encoded */
/* entries.  It should be used on strings that have been retrieved     */
/* from a web server.                                                  */

FUNCTION URL-DECODE RETURNS CHARACTER (INPUT r AS CHARACTER):

  DEF VAR l AS INTEGER NO-UNDO.     /* length of r */
  DEF VAR i AS INTEGER NO-UNDO.     /* index in r */
  DEF VAR c AS CHARACTER NO-UNDO.   /* char representation of hex */
  DEF VAR s AS CHARACTER NO-UNDO.   /* output string */

  /* If nothing to decode, then return nothing */

  IF r = "" THEN RETURN r.

  ASSIGN l = LENGTH (r).

  DO i = 1 TO l:

    /* If there is no % marker, we are cool with the characters in */
    /* the string.                                                 */

    IF SUBSTRING (r, i, 1) <> "%" THEN DO:

      ASSIGN s = s + SUBSTRING (r, i, 1).
      NEXT.

    END. /* Not a % representation */

    /* Of course, getting here means we are looking at a %.  Figure */
    /* out what character that represents.  Assuming a % would be   */
    /* encoded hexidecimally, so we grab the next two characters as */
    /* the hex value, convert, and then put that on the string.     */

    ASSIGN c = CHR(HexToInt (SUBSTRING(r, i + 1, 2))).

    /* We want to replace the %hh number with the char value we just */
    /* computed and increment i so we move past the number in our    */
    /* original string.                                              */

    ASSIGN 
    i = i + 2
    s = s + c.

  END. /* DO i = 1 TO l */

  RETURN s.

END. /* FUNCTION URL-DECODE () */

/* Use this to set the content so HTTP Header syntax is not needed to be */
/* known by the programmer.                                              */

PROCEDURE SetContent:

  DEF INPUT PARAMETER pContentType AS CHARACTER NO-UNDO.

  PUT STREAM StdOut UNFORMATTED "Content-Type:" + pContentType + "~n~n".
  PUT STREAM StdOut UNFORMATTED "".
  PUT STREAM StdOut UNFORMATTED "".

END.

/* Start of functions to parse QUERY_STRING and HTTP_COOKIE to obtain */
/* values from.  Attempting to match Progress functions as much as    */
/* possible so E4GL code will function with little modification.  In  */
/* the future these may end up in the shared library, cuz string man- */
/* ipulations are sloooooow.  But fast enough for now.                */


/* With this function, we extract the QUERY_STRING that came from the CGI */
/* of the webserver.  We have a 32K limit on the size of this data.       */

FUNCTION Get-Field RETURNS CHARACTER (INPUT T AS CHARACTER):

  DEF VAR i        AS INTEGER NO-UNDO.
  DEF VAR CGIVar   AS CHARACTER NO-UNDO.
  DEF VAR NVP      AS CHARACTER NO-UNDO.
  DEF VAR r        AS CHARACTER NO-UNDO.
  DEF VAR NVPName  AS CHARACTER NO-UNDO.
  DEF VAR NVPValue AS CHARACTER NO-UNDO.
  

  IF REQUEST_METHOD = "GET" THEN
    ASSIGN CGIVar = OS-GETENV("QUERY_STRING").

  /* When processing a post, the post data is stored in an environmental */
  /* varible called POSTDATA in the script that calls runner.p.  In      */
  /* other words, you want:                                              */
  /*  export POSTDATA=$(cat -)                                           */
  /* in your calling script to capture POST data from stdin before get-  */
  /* ting here!                                                          */

  ELSE 
    ASSIGN CGIVar = OS-GETENV("POSTDATA").

  /* We usually get +'s for spaces in this data, so lets clean it up some */

  ASSIGN CGIVar = REPLACE (CGIVar, "+", " ").
 
  /* Use for practicin' my parsin' */
  /* ASSIGN CGIVar = "this=ah&that=oh". */

  /* Look through our assorted nvp, if we have two or more nvp's with the */
  /* same name, make a comma delimited list out of the value.             */

  /* Fix problem where a value contains a string with the same value as */
  /* the name in another NVP.                                           */


  ASSIGN r = "".
  DO i = 1 TO NUM-ENTRIES (CGIVar,"&"):

    /* Pull out an name-value pair segment */
    ASSIGN NVP = ENTRY(i, CGIVar, "&").

    /* Pull out the name portion */
    ASSIGN NVPName = ENTRY(1, NVP, "=").

    /* If name doesn't match the T passed in, then move on to next NVP */
    IF NVPName <> T THEN NEXT.

    /* If we have a winner! */
    /* Change - for multiple choice list boxes, make a comma delimited */
    /* list.                                                           */

    ASSIGN r = r +
               IF r <> "" THEN "," + ENTRY (2, NVP, "=")
               ELSE ENTRY(2, NVP, "=").


  END.

  /* Clean up any hexidecimal representations in r before returning */
  /* it to the caller program.                                      */

  ASSIGN r = URL-DECODE (r).
  RETURN r.

END. /* FUNCTION Get-Field () */

/* With this function, we examine the cookies that were sent back from the */
/* CGI of the web server.  We have a 32K limit on the size of this data.   */

FUNCTION Get-Cookie RETURNS CHARACTER (INPUT T AS CHARACTER):

  DEF VAR i      AS INTEGER NO-UNDO.
  DEF VAR CGIVar AS CHARACTER NO-UNDO.
  DEF VAR NVP    AS CHARACTER NO-UNDO.
  DEF VAR r      AS CHARACTER NO-UNDO.

  ASSIGN CGIVar = OS-GETENV("HTTP_COOKIE").

  /* Use for practicin' my parsin' */
  /* ASSIGN CGIVar = "this=ah;that=oh". */

  /* Look through our assorted nvp, if we have two or more nvp's with the */
  /* same name, make a comma delimited list out of the value.             */

  DO i = 1 TO NUM-ENTRIES (CGIVar,";"):

    ASSIGN NVP = ENTRY(i, CGIVar, ";")
           r = "".

    /* If we have a winner! */

    IF INDEX (NVP, T) <> 0 THEN DO:

      ASSIGN r = r +
                 IF r <> "" THEN "," + ENTRY (2, NVP, "=")
                 ELSE ENTRY(2, NVP, "=").

      /* Clean up any hexidecimal representations in r before returning */
      /* it to the caller program.                                      */

      ASSIGN r = URL-DECODE (r).
      RETURN r.

    END. 

  END.

  RETURN "".

END. /* FUNCTION Get-Cookie () */

/* In this function, we search a field or a cookie for a name value   */
/* pair (nvp).                                                        */

FUNCTION Get-Value RETURNS CHARACTER (INPUT T AS CHARACTER):

  DEF VAR r AS CHARACTER NO-UNDO.

  ASSIGN r = Get-Field (t).

  IF r = "" THEN
    ASSIGN r = Get-Cookie (t).

  RETURN r.

END. /* FUNCTION Get-Value () */

/* The following sets a cookie based on the set-cookie API arguments */
/* from Progress.  The cookie syntax is derived from RFC2109 avail-  */
/* able here: http://www.cis.ohio-state.edu/htbin/rfc/rfc2109.html   */
/* Warning: This function assumes you got a clue, unlike Progress' - */
/* there is little value checking.                                   */

FUNCTION Set-Cookie RETURNS CHARACTER
 (INPUT pName    AS CHARACTER,
  INPUT pValue   AS CHARACTER,
  INPUT pDate    AS DATE,
  INPUT pTime    AS INTEGER,
  INPUT pPath    AS CHARACTER,
  INPUT pDomain  AS CHARACTER,
  INPUT pOptions AS CHARACTER):

  DEF VAR CookiePhrase AS CHARACTER NO-UNDO.
/*
  DEF VAR SCRIPT_NAME AS CHARACTER NO-UNDO.
  DEF VAR SERVER_NAME AS CHARACTER NO-UNDO.

  ASSIGN SCRIPT_NAME = OS-GETENV("SCRIPT_NAME")
         SERVER_NAME = OS-GETENV("SERVER_NAME").
*/
  /* Determine if we are getting unknowns, if so, then we want or defaults */
  /* NOTE: Where domain, we use server name.  This may not jive with what  */
  /* Progress did with their set-cookie function.                          */

  ASSIGN
  pName    = IF pName = ? THEN "" ELSE pName
  pValue   = IF pValue = ? THEN "" ELSE pValue
  /* pDate    = IF pDate = ? THEN "" ELSE pDate */
  /* pTime    = IF pTime = ? THEN "" ELSE pTime */
  pPath    = IF pPath = ? THEN SCRIPT_NAME ELSE pPath
  pDomain  = IF pDomain = ? THEN SERVER_NAME ELSE pDomain
  pOptions = IF pOptions = ? THEN "" ELSE pOptions.

  ASSIGN CookiePhrase = 'Set-Cookie:&1=&2; Version=1; Path=&3;'.

  ASSIGN CookiePhrase = SUBSTITUTE (CookiePhrase,
                                    pName,
                                    pValue,
                                    pPath,
                                    pDomain).

  PUT STREAM StdOut UNFORMATTED CookiePhrase "~n".

  RETURN CookiePhrase.

END FUNCTION.  /* set-cookie */

/* Delete a cookie.  Basically a call to set-cookie() with a blank value */

FUNCTION Delete-Cookie RETURNS CHARACTER (INPUT CookieName AS CHARACTER, INPUT A AS CHARACTER, INPUT B AS CHARACTER):

  return set-cookie (CookieName, "", ?, ?, ?, ?, ?).

END.

/* There are times when data may contain HTML meta characters.  Use this */
/* function to use the tokens that should be used for these.  Compatible */
/* with Progress Web-Speed.  Note you want to do the & first, else you   */
/* will smack yourself in the head later.                                */

FUNCTION HTML-Encode RETURNS CHARACTER (INPUT pText AS CHARACTER):

  ASSIGN pText = REPLACE (pText, "&", "&amp;") 
         pText = REPLACE (pText, "~"", "&quot;") 
         pText = REPLACE (pText, "<", "&lt;") 
         pText = REPLACE (pText, ">", "&gt;") .

  RETURN pText.

END. 

/* This function will return the CGI varible values in function form.  */
/* Some existing programs use this function so here it is!             */
/* THIS DOESN'T BEHAVE EXACTLY AS THE WEBSPEED ONE.  It won't send     */
/* back all the varibles with an argument of ?.  It won't send back a  */
/* blank "" if the varible name is invalid.                            */

FUNCTION GET-CGI RETURNS CHARACTER (INPUT pText AS CHARACTER):

  DEF VAR cValidVars AS CHARACTER NO-UNDO.

  ASSIGN cValidVars = "HTTP_ACCEPT_LANGUAGE,SERVER_SIGNATURE,SCRIPT_FILENAME,HTTP_ACCEPT_CHARSET,PROMSGS,SERVER_NAME,HTTP_CONNECTION,CONTENT_TYPE,REMOTE_ADDR,WRKDIR,REQUEST_URI,PATH_INFO,TERM,HOSTTYPE,PATH,HTTP_HOST,REMOTE_PORT,REQUEST_METHOD,SHELL,GATEWAY_INTERFACE,QUERY_STRING,SERVER_ADDR,SERVER_SOFTWARE,SERVER_PROTOCOL,DLC,SERVER_PORT,DOCUMENT_ROOT,OSTYPE,HTTP_USER_AGENT,HTTP_ACCEPT,SCRIPT_NAME,SHLVL,SERVER_ADMIN,HTTP_REFERER,CONTENT_LENGTH,HTTP_ACCEPT_ENCODING,PATH_TRANSLATED,_,useConnID".

  /* By progress definition, return valid vars when a ? is sent along */

  IF pText = ? THEN RETURN cValidVars.

  /* By progress definition, if the varible is invalid, send back a blank */

  IF INDEX(cValidVars, pText) = 0 THEN RETURN " ".

  /* As of the moment, this is a convenient environmental nab - in the */
  /* future it will have to parse the BLUE_MSG structure to nab the    */
  /* value.                                                            */

  RETURN OS-GETENV(pText).

END. /* FUNCTION GET-CGI () */

/* Helps handle proxies and browsers not set to Refresh Page on every hit. */

FUNCTION headerTime RETURNS CHARACTER().
    DEF VAR expdate AS CHARACTER format "x(50)" NO-UNDO.
    DEF VAR daylist AS CHARACTER 
    INITIAL "Sun,Mon,Tue,Wed,Thu,Fri,Saturday" NO-UNDO.
    DEF VAR monlist AS CHARACTER 
    INITIAL "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec" NO-UNDO.

    expdate = ENTRY(WEEKDAY(TODAY),daylist).
    expdate = expDate + ", ".
    expdate = expDate + STRING(DAY(TODAY)) + " ".
    expDate = expdate + entry(MONTH(TODAY),monlist) + " ".
    expdate = expdate + STRING(YEAR(TODAY),"9999") + " ".
    expdate = expdate + STRING(TIME,"HH:MM:SS") + " GMT".
    RETURN expDate.
END.

PROCEDURE LastModified.
  &IF "{&EXPIRE}" = "YES" &THEN
  LAST-modified = headerTime().
  {&OUT} "Last-Modified: " LAST-modified SKIP.
  {&OUT} "Expires: " LAST-modified SKIP.
  &ENDIF
END.

/* Provide the URL-Field function.  Pretty simple, just URL-ENCODE() the  */
/* arguments delmited by the delimiter field.                             */

FUNCTION URL-Field RETURNS CHARACTER
(INPUT cName AS CHARACTER,
 INPUT cValue AS CHARACTER,
 INPUT cDelimiter AS CHARACTER):

  IF cDelimiter = ? THEN ASSIGN cDelimiter = "&amp;".

  RETURN cDelimiter + URL-ENCODE(cName, ?) + "=" + URL-ENCODE(cValue, ?).

END. /* FUNCTION URL-Field() */

/* Must be below definitions for GET-VALUE() and URL-FIELD() */

FUNCTION URL-Field-List RETURNS CHARACTER
  (INPUT cNames AS CHARACTER,
   INPUT cDelimiter AS CHARACTER):

  DEF VAR i       AS INTEGER NO-UNDO.
  DEF VAR cName   AS CHARACTER NO-UNDO.
  DEF VAR cValue  AS CHARACTER NO-UNDO.
  DEF VAR cResult AS CHARACTER NO-UNDO.

  /* Handle messed up inputs */
  IF cNames = "" OR cNames = ? THEN RETURN "".
  IF cDelimiter = "" THEN cDelimiter = ?.

  DO i = 1 TO NUM-ENTRIES(cNames):
    ASSIGN
      cName = ENTRY(i, cNames)
      cValue = GET-VALUE(cName).

    IF cValue <> "" THEN
      ASSIGN cResult = cResult + URL-Field(cName, cValue, cDelimiter).

  END.
    
  RETURN cResult.

END.  /* URL-field-list () */

/* Below URL-Field-List() */

FUNCTION URL-Format RETURNS CHARACTER
  (INPUT cURL AS CHARACTER,
   INPUT cNames AS CHARACTER,
   INPUT cDelimiter AS CHARACTER):

  DEF VAR cResult AS CHARACTER NO-UNDO.

  ASSIGN cResult = URL-Field-List(cNames, cDelimiter).

  RETURN (IF cURL = ? THEN SelfURL ELSE cURL) +
         (IF cResult = "" THEN "" ELSE "?" + cResult).

END.  /* URL-Format () */

/* Some existing E4GL programs use the OUTPUT-HEADERS internal procedure. */
/* To make this the most compatible as possible, see if there is an in-   */
/* ternal procedure called OUTPUT-HEADERS and run it if it exists.        */

IF THIS-PROCEDURE:GET-SIGNATURE("OUTPUT-HEADERS") BEGINS "procedure" THEN
  RUN OUTPUT-HEADERS.

/* Placed in SetContent.i which is included in generated source.  This is */
/* to help clean up the use of sga_util.i in screens that do not need the */
/* content output (SourceLab.html) and batch programs.                    */

/* RUN SetContent ("text/html"). */

&ENDIF

